﻿var _isApp = true;

var _target = 0;

/* Get Pattern Type */
var _patternType = getParameter('ptType');
var _strPatternType;
switch(_patternType) {
	case '1':
		_strPatternType = 'pro';
		break;
	case '2':
		_strPatternType = 'legend';
		break;
	default:
		_strPatternType = 'basic';
		break;
}

/* Get List Size */
var _more = getParameter('list_size');
if(_more == '') _more =10000;
else _more = parseInt(_more);

/* Premium Pass */
var _flagPremiumPass = getParameter('premium_pass_flag');
if(_flagPremiumPass == '') _flagPremiumPass = 'off';


function viewLoading(p) {
	if(_isApp) document.location.href = 'tapsonicapp://more_start?position='+p;
	else {
		if(p == 1) viewMoreTop();
		else if(p == 2) viewMoreFoot();
		else viewMore();
	}
}

function viewMoreApp(p) {
	if(p == 1) viewMoreTop();
	else if(p == 2) viewMoreFoot();
	else viewMore();

	// alert to app end
	document.location.href = 'tapsonicapp://more_end';
}

/* Make Music List HTML */
function makeMusicList(d,p,pos,num,isNum) {
	var strFlag = '';
	var tags = [];

	// Flag String Create
	for(var i=0;i<d.flags.length;i++) {
		if(i == 0) strFlag += d.flags[i];
		else strFlag += '|' + d.flags[i];
	}

	tags.push('<div id="row'+d.piid+'">');
	tags.push('<a name="'+d.tiid+'"></a>');

	var isNew = strFlag.indexOf('new') >= 0;
	var isDown = strFlag.indexOf('down') >= 0;
	var isPremium = strFlag.indexOf('premium') >= 0;
	var isPurchased = strFlag.indexOf('purchased') >= 0;
	var isUnlocked = strFlag.indexOf('unlocked') >= 0;
	var isChallenge = strFlag.indexOf('challenge') >= 0;
	var isSale = strFlag.indexOf('sale') >= 0;
	var isHot = strFlag.indexOf('hot') >= 0;
	var isNotCoupon = strFlag.indexOf('not_enough_coupon') >= 0;
	var isUnlimit = strFlag.indexOf('unlimit') >= 0;

	// Background Image
	if(isPurchased && isHot) tags.push('<div class="my_premium_hot">');
	else if(isPurchased) tags.push('<div class="my_premium">');
	else if(isHot) tags.push('<div class="hot_list">');
	else tags.push('<div class="list_normal">');

	tags.push('<ul>');

	// Sale Print
	if(isPremium && !isPurchased) tags.push('<li class="buy_only"><img src="./images/select/nm_buy2.png" class="btnCursor" onClick="buyPremium('+d.tiid+');" /></li>');
	else tags.push('<li class="buy_only"></li>');

	// Number Print
	if(isNum) {
		num++;
		if(pos == 1) tags.push('<li class="no_free">'+num+'</li>');
		else tags.push('<li class="no_hot">'+num+'</li>');
	}

	// New Icon Print
	if(isNew) tags.push('<li class="new"><img src="./images/select/new_icon.png" alt="NEW" /></li>');
	else tags.push('<li class="new"></li>');

	// Disc Image Print
	tags.push('<li class="disc">');
	if(!isUnlocked) tags.push('<span class="down"><img src="./images/select/lock.png" width="31" height="37" alt="UNLOCK" /></span>');
	else if(isDown) tags.push('<span class="down"><img src="./images/select/select_music_icon_down.png" width="31" height="37" alt="DOWNLOAD" /></span>');
	else tags.push('<span class="down"></span>');

	tags.push('<img src="'+d.local_image_thumb_url+'" onError="this.src=\''+d.image_thumb_url+'\'" width="40" height="40" alt="DISC" />');
	tags.push('</li>');

	if(!isUnlocked) tags.push('<li class="select" onClick="return;"></li>');
	else tags.push('<li class="select btnCursor" onClick="playMusic('+d.piid+');"></li>');

	tags.push('<li class="info">');

	// Album Name
	tags.push('<span class="title"><p id="area">'+d.track_nm+'</p></span>');

	// Album Artist
	tags.push('<span class="writer"><p id="area">'+d.artist_nm+'</p></span>');

	tags.push('<span id="zPoint">');

	// Premium Pass or Premium
	
	if(isPurchased) tags.push('<img src="./images/select/icon_premium_purchased.png" alt="premium" />');
	// Premium && Music Point
	else if(isPremium && isNotCoupon) tags.push('<img src="./images/select/icon_premium.png" alt="premium" /><span class="pointoff">'+d.coupon+'</span>');
	else if(isPremium) tags.push('<img src="./images/select/icon_premium.png" alt="premium" /><span class="point">'+d.coupon+'</span>');
	// Free mark
	else if(d.coupon == 0) tags.push('<img src="./images/select/icon_free.png" width="60" height="16" alt="FREE" />');
	// Music Point
	else if(isNotCoupon) tags.push('<span class="pointoff">'+d.coupon+'</span>');
	else tags.push('<span class="point">'+d.coupon+'</span>');

	tags.push('</span>');

	tags.push('</li>');

	if(!isChallenge) {
		// All Combo Print
		tags.push('<span id="zCombo">');

		if(d.all_combo > 49) tags.push('<li class="ico_king"><img src="./images/select/'+p+'_king.png" /></li>');
		else if(d.all_combo > 0) tags.push('<li class="ico_'+p+'_perf">'+d.all_combo+'</li>');
		else tags.push('<li class="empty_box"></li>');

		tags.push('</span>');

		// Rank Print
		tags.push('<span id="zRank">');

		if(d.rank != '') tags.push('<li class="ico_s"><img src="./images/select/rank_'+d.rank.toLowerCase()+'.png" width="31" height="33" alt="rank_s" /></li>');
		else tags.push('<li class="empty_box"></li>');

		tags.push('</span>');

		// Challenge Print
		tags.push('<li class="chall_now"></li>');
	} else {
		tags.push('<span id="zCombo"></span>');
		tags.push('<span id="zRank"></span>');
		tags.push('<li class="chall_now"><img src="./images/select/challenge_now.png" alt="callenge_now"></li>');
	}

	// Buy Icon Print
	if(isPremium && !isPurchased && isSale) tags.push('<li class="btn_buy_sale" onClick="buyPremium('+d.tiid+');"><img src="./images/select/sale_buy.png" width="43" height="32" alt="SALE" /></li>');
	else if(isPremium && !isPurchased) tags.push('<li class="btn_buy_only" onClick="buyPremium('+d.tiid+');"><img src="./images/select/nm_buy.png" width="26" height="27" alt="CART" /></li>');

	// Difficulty Print
	tags.push('<li class="difficulty"><span class="difficulty'+d.difficulty+'"></span></li>');

	tags.push('</ul>');
	tags.push('</div>');
	tags.push('</div>');

	return tags.join('');
}

function makeMusicListChallenge(d,p) {
	var strFlag = '';
	var tags = [];

	// Flag String Create
	for(var i=0;i<d.flags.length;i++) {
		if(i == 0) strFlag += d.flags[i];
		else strFlag += '|' + d.flags[i];
	}

	tags.push('<div id="row'+d.piid+'">');
	tags.push('<a name="'+d.tiid+'"></a>');

	var isNew = strFlag.indexOf('new') >= 0;
	var isDown = strFlag.indexOf('down') >= 0;
	var isPremium = strFlag.indexOf('premium') >= 0;
	var isPurchased = strFlag.indexOf('purchased') >= 0;
	var isUnlocked = strFlag.indexOf('unlocked') >= 0;
	var isChallenge = strFlag.indexOf('challenge') >= 0;
	var isSale = strFlag.indexOf('sale') >= 0;
	var isHot = strFlag.indexOf('hot') >= 0;
	var isNotCoupon = strFlag.indexOf('not_enough_coupon') >= 0;
	var isUnlimit = strFlag.indexOf('unlimit') >= 0;

	// Background Image
	if(isPurchased && isHot) tags.push('<div class="my_premium_hot">');
	else if(isPurchased) tags.push('<div class="my_premium">');
	else if(isHot) tags.push('<div class="hot_list">');
	else tags.push('<div class="list_normal">');

	tags.push('<ul>');
	//if(!isUnlocked) tags.push('<ul>');
	//else tags.push('<ul onClick="playMusic('+d.piid+');">');

	// Buy Print
	if(isPremium && !isPurchased) tags.push('<li class="buy_only"><img src="./images/select/nm_buy2.png" class="btnCursor" onClick="buyPremium('+d.tiid+');" /></li>');
	else tags.push('<li class="buy_only"></li>');

	// Clear && New Icon Print
	if(isNew) tags.push('<li class="new"><img src="./images/select/new_icon.png" /></li>');
	else tags.push('<li class="new"></li>');

	// Disc Image Print
	tags.push('<li class="disc">');
	if(!isUnlocked) tags.push('<span class="down"><img src="./images/select/lock.png" width="31" height="37" alt="UNLOCK" /></span>');
	else if(isDown) tags.push('<span class="down"><img src="./images/select/select_music_icon_down.png" width="31" height="37" alt="DOWNLOAD" /></span>');
	else tags.push('<span class="down"></span>');

	tags.push('<img src="'+d.local_image_thumb_url+'" onError="this.src=\''+d.image_thumb_url+'\'" width="40" height="40" alt="DISC" />');
	tags.push('</li>');

	if(!isUnlocked) tags.push('<li class="select" onClick="return;"></li>');
	else tags.push('<li class="select btnCursor" onClick="playMusic('+d.piid+');"></li>');

	tags.push('<li class="info">');

	// Album Name
	tags.push('<span class="title"><p id="area">'+d.track_nm+'</p></span>');

	// Album Artist
	tags.push('<span class="writer"><p id="area">'+d.artist_nm+'</p></span>');

	tags.push('<span id="zPoint">');

	// Premium Pass or Premium
	
	if(isPurchased) tags.push('<img src="./images/select/icon_premium_purchased.png" alt="premium" />');
	// Premium && Music Point
	else if(isPremium && isNotCoupon) tags.push('<img src="./images/select/icon_premium.png" alt="premium" /><span class="pointoff">'+d.coupon+'</span>');
	else if(isPremium) tags.push('<img src="./images/select/icon_premium.png" alt="premium" /><span class="point">'+d.coupon+'</span>');
	// Free mark
	else if(d.coupon == 0) tags.push('<img src="./images/select/icon_free.png" width="60" height="16" alt="FREE" />');
	// Music Point
	else if(isNotCoupon) tags.push('<span class="pointoff">'+d.coupon+'</span>');
	else tags.push('<span class="point">'+d.coupon+'</span>');

	tags.push('</span>');

	tags.push('</li>');

	if(!isChallenge) {
		// All Combo Print
		tags.push('<span id="zCombo">');
		if(d.all_combo > 49) tags.push('<li class="ico_king"><img src="./images/select/'+p+'_king.png" alt="legend" /></li>');
		else if(d.all_combo > 0) tags.push('<li class="ico_'+p+'_perf">'+d.all_combo+'</li>');
		else tags.push('<li class="empty_box"></li>');
		tags.push('</span>');

		// Rank Print
		tags.push('<span id="zRank">');
		if(d.rank != '') tags.push('<li class="ico_s"><img src="./images/select/rank_'+d.rank.toLowerCase()+'.png" width="31" height="33" alt="rank_s" /></li>');
		else tags.push('<li class="empty_box"></li>');
		tags.push('</span>');

		// Challenge Print
		tags.push('<li class="chall_now"></li>');
	} else {
		tags.push('<span id="zCombo"></span>');
		tags.push('<span id="zRank"></span>');
		tags.push('<li class="chall_now"><img src="./images/select/challenge_now.png" alt="callenge_now"></li>');
	}

	// Buy Icon Print
	if(isPremium && !isPurchased && isSale) tags.push('<li class="btn_buy_sale" onClick="buyPremium('+d.tiid+');"><img src="./images/select/sale_buy.png" width="43" height="32" alt="SALE" /></li>');
	else if(isPremium && !isPurchased) tags.push('<li class="btn_buy_only" onClick="buyPremium('+d.tiid+');"><img src="./images/select/nm_buy.png" width="26" height="27" alt="CART" /></li>');

	// Difficulty Print
	tags.push('<li class="difficulty"><span class="difficulty'+d.difficulty+'"></span></li>');

	tags.push('</ul>');
	tags.push('</div>');
	tags.push('</div>');

	return tags.join('');
}

function reloadRow(d) {
	var strFlag = '';

	// Flag String Create
	for(var i=0;i<d.flags.length;i++) {
		if(i == 0) strFlag += d.flags[i];
		else strFlag += '|' + d.flags[i];
	}

	var num = d.piid;
	var isNew = strFlag.indexOf('new') >= 0;
	var isDown = strFlag.indexOf('down') >= 0;
	var isPurchased = strFlag.indexOf('purchased') >= 0;
	var isUnlocked = strFlag.indexOf('unlocked') >= 0;
	var isChallenge = strFlag.indexOf('challenge') >= 0;
	var isUnlimit = strFlag.indexOf('unlimit') >= 0;
	var isSale = strFlag.indexOf('sale') >= 0;
	var isHot = strFlag.indexOf('hot') >= 0;

	if($('#row'+num).html()) {
		if(isUnlocked) $('#row'+num+' .select').attr('onClick','playMusic('+d.piid+')');

		if(isNew) $('#row'+num+' .new').html('<img src="./images/select/new_icon.png" alt="new" />');
		else $('#row'+num+' .new').html('');

		if(!isUnlocked) $('#row'+num+' .down').html('<img src="./images/select/lock.png" width="31" height="37" alt="unlocked" />');
		else if(isDown) $('#row'+num+' .down').html('<img src="./images/select/select_music_icon_down.png" width="31" height="37" alt="download" />');
		else $('#row'+num+' .down').html('');

		if(isPurchased) {
			if(isHot) $('#row'+num+' .hot_list').removeClass('hot_list').addClass('my_premium_hot');
			else $('#row'+num+' .list_normal').removeClass('list_normal').addClass('my_premium');

			$('#row'+num+' .point').remove();
			$('#row'+num+' .pointoff').remove();
			$('#row'+num+' .btn_buy_only').remove();
			$('#row'+num+' .buy_only').remove();

			
		}

		if(!isChallenge) {
			if(d.all_combo > 49) $('#row'+num+' #zCombo').html('<li class="ico_king"><img src="./images/select/'+_strPatternType+'_king.png" alt="king" /></li>');
			else if(d.all_combo > 0) $('#row'+num+' #zCombo').html('<li class="ico_'+_strPatternType+'_perf">'+d.all_combo+'</li>');
			else $('#row'+num+' #zCombo').html('<li class="empty_box"></li>');

			if(d.rank == '') $('#row'+num+' #zRank').html('<li class="empty_box"></li>');
			else $('#row'+num+' #zRank').html('<li class="ico_s"><img src="./images/select/rank_'+d.rank.toLowerCase()+'.png" width="31" height="33" alt="rank_s" /></li>');

			$('#row'+num+' .chall_now').html('');
		} else {
			$('#row'+num+' #zCombo').html('');
			$('#row'+num+' #zRank').html('');
			$('#row'+num+' .chall_now').html('<img src="./images/select/challenge_now.png" alt="callenge_now">');
		}

		var newHtml = $('#wrap #row'+num).html();
		newHtml = '<div id="row'+num+'">' + newHtml + '</div>';

		putLocalStorage(num,newHtml,d.version);
	} else {
		putLocalStorage(num,'','');
	}

	var pitemds = _data.pitemds;
	for(var i=0; i != pitemds.length; ++i)
	{
	   if (pitemds[i].piid == num)
	   {
		  pitemds[i] = d;
		  break;
	   }
	}

//	_data.pitemds[d.index] = d;

	removeMemStorage();
	putMemStorage();
}

function cutLength(s,l) {
	var v;
	var t = 0;

	if(s == null || s.length < 0) return s;

	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) t += 2;
		else t++;

		if(t >= l) {
			v = s.substring(0,i) + '...';
			return v;
		}
	}
}

function getLength(s) {
	var l = 0;
	if(s == null) return 0;
	for(var i=0;i<s.length;i++) {
		var c = s.charCodeAt(i);
		if (c >= 0x1000) l += 2;
		else l++;
	}

   return l;
}

function getParameter(p) {
	if(document.location.search.substring(1).length > 0) {
		var arrQueryString = document.location.search.substring(1).split('&');
		var arrParam = new Array;
		for(var i=0;i<arrQueryString.length;i++) {
			arrParam = arrQueryString[i].split('=');

			if(arrParam[0] == p) return arrParam[1];
		}

		return '';
	} else {
		return '';
	}
}

function chkValue(s) {
	if(typeof(s) == 'undefined') return '';
	else if(!s) return '';
	else return s;
}

function playMusic(piid) {
	event.stopPropagation();
	var url = 'tapsonicapp://select?piid='+piid;
	document.location.href = url;
}

function buyPremium(tiid) {
	event.stopPropagation();
	var url = 'tapsonicapp://buy_premium?tiid='+tiid;
	document.location.href = url;
}

function moveShop() {
	var url = 'tapsonicapp://go_premium_shop';
	document.location.href = url;
}

function moveCategory(c) {
	var url = 'tapsonicapp://open_category?name='+c;
	document.location.href = url;
}

// Group Folding
function changeTabToggle(o,n) {
	$('#wrap #group:eq('+n+')').toggle(1);

	if($(o).hasClass('ms_bar_up')) {$(o).removeClass('ms_bar_up'); $(o).addClass('ms_bar_down');}
	else if($(o).hasClass('ms_bar_down')) {$(o).removeClass('ms_bar_down'); $(o).addClass('ms_bar_up');}
}

function toggleBlink() {
	if($('.more_list').text() == '') $('.more_list').text('곡 리스트 로딩중..')
	else $('.more_list').text('');
}

function getScrollXY(p) {
  var scrOfX = 0, scrOfY = 0;
  if( typeof( window.pageYOffset ) == 'number' ) {
    //Netscape compliant
    scrOfY = window.pageYOffset;
    scrOfX = window.pageXOffset;
  } else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
    //DOM compliant
    scrOfY = document.body.scrollTop;
    scrOfX = document.body.scrollLeft;
  } else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
    //IE6 standards compliant mode
    scrOfY = document.documentElement.scrollTop;
    scrOfX = document.documentElement.scrollLeft;
  }

  if(p == 'x') return scrOfX;
  else return scrOfY;
}

function getClientSize(p) {
  var myWidth = 0, myHeight = 0;

  if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
    //IE 4 compatible
    myWidth = document.body.clientWidth;
    myHeight = document.body.clientHeight;
  }
  else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
    //IE 6+ in 'standards compliant mode'
    myWidth = document.documentElement.clientWidth;
    myHeight = document.documentElement.clientHeight;
  }
  else if( typeof( window.innerWidth ) == 'number' ) {
    //Non-IE
    myWidth = window.innerWidth;
    myHeight = window.innerHeight;
  }

  if(p == 'x') return myWidth;
  else return myHeight;
}